import * as Promise from 'bluebird';
import { OrderedMap } from 'immutable';
import { Action, Reducible, Dispatch } from 'pretur.redux';
import { Query, Synchronizer, Fetcher } from 'pretur.sync';
import Querier from './query/Querier';
import Set from './data/Set';
export default class Reactive<T extends Set<any, any, any>> implements Reducible {
    private _set;
    private _querier;
    private _initialized;
    private _buildFetcher;
    constructor(set: T, query: Query, buildFetcher?: () => Fetcher);
    set: T;
    items: OrderedMap<number, any>;
    querier: Querier;
    initialized: boolean;
    valid: boolean;
    reduce(action: Action<any, any>): this;
    init(dispatch: Dispatch, fetcher: Fetcher): Promise<void>;
    initIfNeeded(dispatch: Dispatch, fetcher: Fetcher): void;
    forceRefresh(dispatch: Dispatch, fetcher: Fetcher): Promise<void>;
    ensureValidity(dispatch: Dispatch): boolean;
    sync(synchronizer: Synchronizer): void;
    ensureValidityAndSync(dispatch: Dispatch, synchronizer: Synchronizer, autoDecay?: boolean): boolean;
    private clone();
}
